#--
# DO NOT MODIFY!!!!
# This file is automatically generated by rex 1.0.7
# from lexical definition file "lib/gitlab-zoql/parser/parser.rex".
#++

require 'racc/parser'
# -*- fill-column: 30; -*-

class GitlabZOQL::Parser < Racc::Parser
      require 'strscan'

      class ScanError < StandardError ; end

      attr_reader   :lineno
      attr_reader   :filename
      attr_accessor :state

      def scan_setup(str)
        @ss = StringScanner.new(str)
        @lineno =  1
        @state  = nil
      end

      def action
        yield
      end

      def scan_str(str)
        scan_setup(str)
        do_parse
      end
      alias :scan :scan_str

      def load_file( filename )
        @filename = filename
        File.open(filename, "r") do |f|
          scan_setup(f.read)
        end
      end

      def scan_file( filename )
        load_file(filename)
        do_parse
      end


        def next_token
          return if @ss.eos?

          # skips empty actions
          until token = _next_token or @ss.eos?; end
          token
        end

        def _next_token
          text = @ss.peek(1)
          @lineno  +=  1  if text == "\n"
          token = case @state
            when nil
          case
                  when (text = @ss.scan(/\'/i))
                     action { @state = :STRS;  [:quote, text] }

                  when (text = @ss.scan(/[0-9]+/i))
                     action { [:unsigned_integer, text.to_i] }

                  when (text = @ss.scan(/\s+/i))
                    ;

                  when (text = @ss.scan(/AND\b/i))
                     action { [:AND, text] }

                  when (text = @ss.scan(/COUNT\b/i))
                     action { [:COUNT, text] }

                  when (text = @ss.scan(/ELSE\b/i))
                     action { [:ELSE, text] }

                  when (text = @ss.scan(/FROM\b/i))
                     action { [:FROM, text] }

                  when (text = @ss.scan(/NULL\b/i))
                     action { [:NULL, text] }

                  when (text = @ss.scan(/OR\b/i))
                     action { [:OR, text] }

                  when (text = @ss.scan(/SELECT\b/i))
                     action { [:SELECT, text] }

                  when (text = @ss.scan(/WHERE\b/i))
                     action { [:WHERE, text] }

                  when (text = @ss.scan(/!=/i))
                     action { [:not_equals_operator, text] }

                  when (text = @ss.scan(/=/i))
                     action { [:equals_operator, text] }

                  when (text = @ss.scan(/<=/i))
                     action { [:less_than_or_equals_operator, text] }

                  when (text = @ss.scan(/</i))
                     action { [:less_than_operator, text] }

                  when (text = @ss.scan(/>=/i))
                     action { [:greater_than_or_equals_operator, text] }

                  when (text = @ss.scan(/>/i))
                     action { [:greater_than_operator, text] }

                  when (text = @ss.scan(/,/i))
                     action { [:comma, text] }

                  when (text = @ss.scan(/\w+/i))
                     action { [:identifier, text] }

                  when (text = @ss.scan(/----/i))
                    ;

                  when (text = @ss.scan(/require/i))
                    ;

          
          else
            text = @ss.string[@ss.pos .. -1]
            raise  ScanError, "can not match: '" + text + "'"
          end  # if

            when :STRS
          case
                  when (text = @ss.scan(/[0-9]+-[0-9]+-[0-9]+T[0-9]+:[0-9]+:[0-9]+\+[0-9]+:[0-9]+/i))
                     action { [:datetime_string, DateTime.parse(text)] }

                  when (text = @ss.scan(/(?:[^\\']|\\.|'')+/i))
                     action {                  [:character_string_literal, text] }

                  when (text = @ss.scan(/\'/i))
                     action { @state = nil;    [:quote, text] }

          
          else
            text = @ss.string[@ss.pos .. -1]
            raise  ScanError, "can not match: '" + text + "'"
          end  # if

        else
          raise  ScanError, "undefined state: '" + state.to_s + "'"
        end  # case state
          token
        end  # def _next_token

end # class
